/*

Copyright _ 2005-7, Dauger Research, Inc.  All rights reserved.

*/


function parseoutput(rawStr) {
	
	var items=rawStr.split(" "); 
	
  
	document.getElementById("queuedjobcount").innerHTML = items[3];//.concat(" queued jobs"); 
	{var thisSecs=parseInt(items[4]); 
	var d=parseInt(thisSecs/86400); 
	var h=parseInt((thisSecs/3600)%24); 
	var m=parseInt((thisSecs/60)%60);  
	document.getElementById("jobspan").innerHTML = (d)+" d "+(h)+" h "+(m)+" m"; 
	//items[4].concat(" seconds job span"); 
	}
	
	var now = new Date();
	var daySeconds=60*(60*now.getHours()+now.getMinutes())+now.getSeconds();
	
	var binsoffset=6; 
	var jobspan=parseInt(items[4]); 
	var bins=parseInt(items[binsoffset]); 
	var maxvalue=1; 
    for(var i=0; i<bins; ++i) {
		if (maxvalue<items[i+1+binsoffset]) 
			maxvalue=items[i+1+binsoffset]; 
		}
	
	var context = document.getElementById('canvas').getContext('2d');
	var wd=document.getElementById('canvas').width;
	var ht=document.getElementById('canvas').height;
	
    context.clearRect(0, 0, wd, ht);
    /*
    context.setFillColor(0.0, 0.0, 1.0, 1.0);
    context.fillRect(0, 0, 120, 240);
    context.setFillColor(1.0, 0.0, 0.0, 0.5);
    context.fillRect(20, 20, 100, 120);
    context.setFillColor(0.0, 0.5, 0.0, 0.5);
    context.fillRect(0, 0, wd, ht);
    */
    
    //delinate the days
if (1) 
	{// with bars
	var drawgrey=jobspan; 
	var lastedge=wd; 
	context.setFillColor(0.5, 0.5, 0.5, 0.4);
    for(var i=0; (86400*i+daySeconds)<jobspan; ++i) {
		var nextedge=(wd-(((86400*i+daySeconds)*wd)/jobspan)); 
		if (drawgrey>0) {
			context.fillRect(nextedge, 0, lastedge-nextedge, ht);
			drawgrey=0; 
			}
		else 
			drawgrey=1; 
		lastedge=nextedge; 
		}
    if (drawgrey>0)
    	context.fillRect(0, 0, lastedge, ht);
    }
if (0) {// with lines
	context.save();
    for(var i=0; (86400*i+daySeconds)<jobspan; ++i) {
		var nextedge=wd-(((86400*i+daySeconds)*wd)/jobspan); 
		context.moveTo(nextedge, ht);
		context.lineTo(nextedge, 0);
		}
	context.restore();
    
	context.lineWidth = 1.0;
	context.strokeStyle = "rgb(128, 128, 128)";
	context.stroke();
    }
    
//	context.save(); different for 10.5
//	context.beginPath();
	context.lineWidth = 2.0;
	context.strokeStyle = "rgb(128, 128, 255)";
	context.moveTo(wd, ht-(ht*items[0+1+binsoffset]/maxvalue));
    for(var i=0; i<bins; ++i) {
		context.lineTo (wd-(i*wd)/bins,ht-(ht*items[i+1+binsoffset]/maxvalue));
		}
//	context.closePath();
    
//	context.restore();
	context.stroke();

	document.getElementById("nodemax").innerHTML = parseInt(maxvalue);
	
	return items[0].concat(" nodes found. ", items[1], " MFlops capacity, ", 
		items[2], " MFlops in use ", items[3], " queued jobs ", items[4], " seconds job range.  Bins:",
		items[6]); 
	
	}

// swap
//
// Swaps out the current fortune for a new one.  Uses the Obj-C/JavaScript widget
// plugin to get the new fortune.
function swap() {
	document.getElementById("jobspan").innerHTML = "Accessing cluster ... please wait"; 
    if (widget) {  
    // var outputStr = widget.system("ps -aux | grep ooch ", null).outputString;

       var outputStr = widget.system("/usr/bin/osascript networkscanscript", null).outputString;

		parseoutput(outputStr);	
		 document.getElementById("quote").innerHTML = " ";
		 				// drop in the new data
	}
	 //	document.getElementById("quote").innerHTML = "message was here";	
}

// next
//
// Performs the transition from the current fortune to the next one.
function next()
{
	hideContent();						// fades out the current fortune
	setTimeout("swap();",500);			// swaps in the new fortune
	setTimeout("showContent();",550);	// fades in the new fortune

}

function poochclick()
{
	widget.openApplication("com.daugerresearch.Pooch");
    var obj = widget.system("/usr/bin/osascript openpoochscript", null);
}

function setup()
{
	{var context = document.getElementById('capacitybar').getContext('2d');
	var wd=document.getElementById('capacitybar').width;
	var ht=document.getElementById('capacitybar').height;
	
    context.clearRect(0, 0, wd, ht);
    }
	next(); 
}


/**************************/
// Animation code
// Handles the fades in and out
/**************************/

var animation = {duration:0, starttime:0, to:1.0, now:1.0, from:0.0, firstElement:null, timer:null};

function showContent()
{

		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('quote');				// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation

}


function hideContent()
{

		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('quote');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();

}


function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

if (window.widget) {
	widget.onshow = next;
}
